const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const arrangement_sections = sequelize.define(
    'arrangement_sections',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

section_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"intro",


"verse",


"chorus",


"bridge",


"outro",


"breakdown",


"drop"

        ],

      },

label: {
        type: DataTypes.TEXT,
      
      

      },

start_bar: {
        type: DataTypes.INTEGER,
      
      

      },

bar_length: {
        type: DataTypes.INTEGER,
      
      

      },

order_index: {
        type: DataTypes.INTEGER,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  arrangement_sections.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.arrangement_sections.belongsTo(db.songs, {
      as: 'song',
      foreignKey: {
        name: 'songId',
      },
      constraints: false,
    });

    db.arrangement_sections.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.arrangement_sections.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.arrangement_sections.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return arrangement_sections;
};


